<template>
  <q-page class="q-pl-md bg-grey-1 splitscreen" role="presentation">
    <q-splitter class="splitscreen__splitter" v-model="panelWidth" :limits="[50,100]">
      <template v-slot:before>
        <q-card class="q-pb-md" flat v-if="presentation" v-bind:id="'detail_' + presentation.id" role="region"
        aria-label="Gerenderde tabellen">
          <q-card-section class="text-primary presentation__heading text-weight-bold" :key="language_switch">
            <div :id="presentation.id" v-html="show_label(presentation)"></div>
          </q-card-section>
          <q-item-label class="q-pa-sm" caption>{{ dts_name }}</q-item-label>


          <TocDetailItem
            v-for="(node, index) in presentation.children"
            v-bind:key="'node_' + index + node.id"
            :node="node"
            :dts_name="dts_name"
            :nt_version="nt_version"
            v-on:nodeClicked="node_clicked"
            v-on:tableVisible="table_visible">
          </TocDetailItem>
        </q-card>
      </template>
      <template v-slot:separator>
      </template>
      <template v-slot:after>
        <div v-if="node" role="region" aria-label="Detail gekozen cell">
          <CellValue :node="node" v-on:close_detail="close_detail"></CellValue>
        </div>
      </template>
    </q-splitter>
  </q-page>
</template>

<script>
import TocDetailItem from "components/TocDetailItem";
import SharedMethods from "components/SharedMethods";
import CellValue from "components/CellValue";


export default {
  name: "TocDetail",
  components: {TocDetailItem, CellValue},
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
    this.show_label = SharedMethods.show_label
  },
  props: {
    presentation: Object,
    dts_name: String,
    nt_version: String,
    scroll_to: undefined
  },
  data() {
    return {
      language_switch: 0,
      panelWidth: 100,
      node: null
    }
  },
  methods: {
    node_clicked: function (node) {
      if (node) {
        this.node = node
        if (this.panelWidth === 100) {
          this.panelWidth = 75
        }
      }
    },
    table_visible: function (id) {
      let activelist = document.getElementsByClassName('active')
      if (activelist.length) {
        for (const item of activelist) {
          if (item.id.startsWith('item_'))
            item.classList.remove('active')
        }
      }
      // find the item in the list
      let toc_el = document.getElementById('item_' + id)
      if (toc_el) {
        toc_el.classList.add('active')
        let offset = toc_el.getBoundingClientRect().top - window.scrollY - 100
        if (offset > (window.innerHeight - 150) || offset < 100) {
          this.$nextTick(() => {
            toc_el.scrollIntoView(true)
          })
        }
      }
    },
    close_detail: function () {
      this.panelWidth = 100
    }
  },
  emits: ['makeActive'],
  watch: {
    "$route.query.lang": function () {
      this.language_switch = this.$route.query.lang
    }
  }
}
</script>

<style scoped lang="scss">
.detail--padding {
  padding: 30px;
}

.presentation__heading {
  border-bottom: 1px solid $primary;
  font-size: 20px;
}

.show_hide {
  position: sticky;
  top: 130px;
}

.splitscreen__splitter {
  height: calc(100vh - 150px);
  width: 98%;
}


</style>
